SetPackageInfo( rec(
PackageName := "Browse",
Version := "1.2",
Date := "19/06/2008",
Subtitle := "ncurses interface and browsing applications",
ArchiveURL := "http://www.math.rwth-aachen.de/~Browse/Browse-1.2",
ArchiveFormats := ".tar.bz2",
Persons := [
  rec(
  LastName := "Breuer",
  FirstNames := "Thomas",
  IsAuthor := true,
  IsMaintainer := true,
  Email := "Thomas.Breuer@Math.RWTH-Aachen.De",
  WWWHome := "http://www.math.rwth-aachen.de/~Thomas.Breuer",
  PostalAddress := "Thomas Breuer\nLehrstuhl D fr Mathematik\nRWTH Aachen\nTemplergraben 64\n52062 Aachen\nGERMANY\n",
  Place := "Aachen",
  Institution := "Lehrstuhl D fr Mathematik, RWTH Aachen"
  ),
  rec(
  LastName := "Lbeck",
  FirstNames := "Frank",
  IsAuthor := true,
  IsMaintainer := true,
  Email := "Frank.Luebeck@Math.RWTH-Aachen.De",
  WWWHome := "http://www.math.rwth-aachen.de/~Frank.Luebeck",
  PostalAddress := "Frank Lbeck\nLehrstuhl D fr Mathematik\nRWTH Aachen\nTemplergraben 64\n52062 Aachen\nGERMANY\n",
  Place := "Aachen",
  Institution := "Lehrstuhl D fr Mathematik, RWTH Aachen"
  )
],
Status := "deposited",
#CommunicatedBy := "Mike Atkinson (St. Andrews)",
#AcceptDate := "08/1999",
README_URL := "http://www.math.rwth-aachen.de/~Browse/README",
PackageInfoURL := 
           "http://www.math.rwth-aachen.de/~Browse/PackageInfo.g",
AbstractHTML := "The <span class='pkgname'>Browse</span> package provides three levels of functionality</p><ul><li>A <span class='pkgname'>GAP</span> interface to the C-library <a href='http://www.gnu.org/software/ncurses/ncurses.html'>ncurses</a>.</li><li>A generic function for interactive browsing through two-dimensional arrays of data.</li><li>Several applications of the first two, e.g., a method for browsing character tables, browsing through the content of some data collections, or some games.</li></ul><p>",
PackageWWWHome := "http://www.math.rwth-aachen.de/~Browse",
PackageDoc := [
              rec(
  BookName := "Browse",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile := "doc/manual.pdf",
  SixFile := "doc/manual.six",
  LongTitle := "ncurses interface and browsing applications",
  Autoload := true
)
],
Dependencies := rec(
  GAP := "4.4.10",
  NeededOtherPackages := [ ["GAPDoc", ">= 1.2"], ],
  SuggestedOtherPackages := [ ["AtlasRep",">=1.3"], [ "IO", ">=2.2" ] ],
  ExternalConditions := ["C-compiler", "ncurses development library"]
),
AvailabilityTest := function()
  if not "ncurses" in SHOW_STAT() and 
     Filename(DirectoriesPackagePrograms("Browse"), "ncurses.so") = fail then
     # maybe we get a new interface and then return an info string here:
##      Info(InfoWarning, 1, "Browse: kernel functions for ncurses not available.");
    return false;
  fi;
  return true;
end,
Autoload := false,
##  BannerString := Concatenation(
##    "    Browse ", ~.Version, " by Thomas Breuer and Frank Lbeck\n",
##    "          ncurses interface and browsing applications"
##  ),
TestFile := "tst/test.tst",
Keywords := ["Browse", "ncurses"]

));


