#############################################################################
##
##  PackageInfo.g   file for the package Gpd version 1.03  (08/10/07)
##  Emma Moore and Chris Wensley 
##

SetPackageInfo( rec(
PackageName := "gpd",
Subtitle := "Groupoids, graphs of groups, and graphs of groupoids",

Version := "1.03",
Date := "08/10/2007",
ArchiveURL := Concatenation( [ 
  "http://www.informatics.bangor.ac.uk/public/mathematics/chda/gpd/gpd.",
  ~.Version ] ), 
ArchiveFormats := ".tar.gz",

TextFiles := ["init.g", "read.g"],
BinaryFiles := ["doc/manual.dvi"],

Persons := [
  rec(
    LastName      := "Moore",
    FirstNames    := "Emma J.",
    IsAuthor      := true,
    IsMaintainer  := false,
    Email         := "emmajmoore@yahoo.co.uk",
    ## WWWHome       := "",
    ## PostalAddress := Concatenation( ["\n", "UK"] ),
    ## Place         := "",
    ## Institution   := ""
  ),
  rec(
    LastName      := "Wensley",
    FirstNames    := "Christopher D.",
    IsAuthor      := true,
    IsMaintainer  := true,
    Email         := "c.d.wensley@bangor.ac.uk",
    WWWHome       := "http://www.informatics.bangor.ac.uk/~cwensley/",
    PostalAddress := Concatenation( [
                       "Dr. C.D. Wensley\n",
                       "School of Informatics\n",
                       "University of Wales, Bangor\n",
                       "Dean Street\n",
                       "Bangor\n",
                       "Gwynedd LL57 1UT\n",
                       "UK"] ),
    Place         := "Bangor",
    Institution   := "University of Wales, Bangor"
  )
],

Status := "deposited",
## CommunicatedBy := "",
## AcceptDate := "",

README_URL := 
  "http://www.informatics.bangor.ac.uk/public/mathematics/chda/gpd/README",
PackageInfoURL :=
  "http://www.informatics.bangor.ac.uk/public/mathematics/chda/gpd/PackageInfo.g",

AbstractHTML :=
 "The Gpd package provides a collection of functions for computing with \
finite groupoids, graph of groups, and graphs of groupoids. \
It provides functions for normal forms of elements in Free Products with \
Amalgamation and in HNN extensions.",

PackageWWWHome := 
 "http://www.informatics.bangor.ac.uk/public/mathematics/chda/gpd/gpd103.html",

PackageDoc := rec(
  BookName  := "Gpd",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "Finite Groupoids and Graphs of Groups",
  Autoload  := true
),

Dependencies := rec(
  GAP := ">=4.4",
  NeededOtherPackages := [ [ "xmod", ">= 2.010" ], 
                         [ "GAPDoc", ">= 1.0" ] ],
  SuggestedOtherPackages := [ ],
  ExternalConditions := [ ]
),

AvailabilityTest := ReturnTrue,

BannerString := Concatenation(
    "-----------------------------------------------------------\n",
    "loading Gpd 1.03 for GAP 4.4 - Emma Moore and Chris Wensley\n",
    "-----------------------------------------------------------\n" ),

Autoload := false,

## TestFile := "tst/testmanual.tst", 

Keywords := ["groupoid","graph of groups","free product with amalgamation",
             "HNN extension"]

));
