#############################################################################
##
#W  PackageInfo.g               GAP 4 Package `IdRel'           Chris Wensley
#W                                                              Anne Heyworth
##
#H  @(#)$Id: PackageInfo.g,v 2.03 2007/10/09 gap Exp $
##

SetPackageInfo( rec(
PackageName := "idrel",
Subtitle := "Identities among relations",

Version := "2.03",
Date := "09/10/2007",
ArchiveURL := Concatenation( [ 
  "http://www.informatics.bangor.ac.uk/public/mathematics/chda/idrel/idrel.",
  ~.Version ] ), 
ArchiveFormats := ".tar.gz",

TextFiles := ["init.g", "read.g"],
BinaryFiles := ["doc/manual.dvi"],

Persons := [
  rec(
    LastName      := "Heyworth",
    FirstNames    := "Anne",
    IsAuthor      := true,
    IsMaintainer  := false,
    Email         := "anne.heyworth@googlemail.com",
    ## WWWHome       := "",
    ## PostalAddress := Concatenation( ["\n", "UK"] ),
    ## Place         := "",
    ## Institution   := ""
  ),
  rec(
    LastName      := "Wensley",
    FirstNames    := "Christopher D.",
    IsAuthor      := true,
    IsMaintainer  := true,
    Email         := "c.d.wensley@bangor.ac.uk",
    WWWHome       := "http://www.informatics.bangor.ac.uk/~cwensley/",
    PostalAddress := Concatenation( [
                       "Dr. C.D. Wensley\n",
                       "School of Computer Science\n",
                       "Bangor University\n",
                       "Dean Street\n",
                       "Bangor\n",
                       "Gwynedd LL57 1UT\n",
                       "UK"] ),
    Place         := "Bangor",
    Institution   := "Bangor University"
  )
],

Status := "deposited",
## CommunicatedBy := "",
## AcceptDate := "",

README_URL := 
  "http://www.informatics.bangor.ac.uk/public/mathematics/chda/idrel/README",
PackageInfoURL :=
  "http://www.informatics.bangor.ac.uk/public/mathematics/chda/idrel/PackageInfo.g",

AbstractHTML :=
 "IdRel is a package for computing the identities among relations of a group presentation using rewriting, logged rewriting, monoid polynomials, module polynomials and Y-sequences.",

PackageWWWHome := 
  "http://www.informatics.bangor.ac.uk/public/mathematics/chda/idrel/idrel203.html",

PackageDoc := rec(
  BookName  := "IdRel",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "Identities among Relations",
  Autoload  := true
),

Dependencies := rec(
  GAP := ">=4.4",
  NeededOtherPackages := [ [ "xmod", ">= 2.010" ], 
                         [ "GAPDoc", ">= 1.0" ] ],
  SuggestedOtherPackages := [ ],
  ExternalConditions := [ ]
),

AvailabilityTest := ReturnTrue,

BannerString := Concatenation( 
    "----------------------------------------------------------------\n",
    "loading IdRel 2.03 for GAP 4.4 - Anne Heyworth and Chris Wensley\n",
    "----------------------------------------------------------------\n" ),

Autoload := false,

## TestFile := "tst/idrel_manual.tst",

Keywords := ["logged rewriting","identities among relations",
             "Y-sequences"]

));
