#############################################################################
##
##  PackageInfo.g file for the package if
##  Marco Costantini
##

SetPackageInfo( rec(
PackageName := "if",
Subtitle := "The GAP InterFace to other Computer Algebra Systems",


Version := "06.03.19",
Date := "19/03/2006",
ArchiveURL := Concatenation([
 "http://www-math.science.unitn.it/~costanti/gap_code/if/if-", 
  ~.Version]),
ArchiveFormats := ".tar.gz",

Persons := [
  rec(
  LastName := "Costantini",
  FirstNames := "Marco",
  IsAuthor := true,
  IsMaintainer := true,
  Email := "costanti@science.unitn.it",
  WWWHome := "http://www-math.science.unitn.it/~costanti/",
  Place := "Trento",
  Institution := "Department of Mathematics, University of Trento"
  )
],

Status := "deposited",
#CommunicatedBy := "",
#AcceptDate := "",

README_URL := "http://www-math.science.unitn.it/~costanti/gap_code/if/README",
PackageInfoURL :=
 "http://www-math.science.unitn.it/~costanti/gap_code/if/PackageInfo.g",

AbstractHTML :=
  "The '<span class=\"pkgname\">if</span>' package provides interfaces \
   from <span class=\"pkgname\">GAP</span> various other computer algebra systems.",

PackageWWWHome := "http://www-math.science.unitn.it/~costanti/#if",

PackageDoc := rec(
  BookName  := "if",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "The GAP interfaces to other CASes",
  Autoload  := true
),

Dependencies := rec(
  GAP := ">=4.2", # >=4.2 under unix or >=4.4 under windows
  NeededOtherPackages := [  ],
  SuggestedOtherPackages := [ [ "GapDoc", ">= 0.99" ],  [ "openmath", ">= 06.01.03" ], [ "singular", ">= 06.01.09" ] ],
  ExternalConditions := [ "Requires the other computer algebra systems" ]
),
AvailabilityTest := ReturnTrue,
Autoload := false,
# the banner
BannerString := 
"The GAP InterFace to other Computer Algebra Systems, by Marco Costantini\n",

TestFile := "tst/testall.g",
#Keywords := ["Groebner bases"]

));

