##############################################################################
##
#W  sl42.g                       Kan Package                     Chris Wensley
#W                                                             & Anne Heyworth
##
##  This file contains generic methods for double coset rewriting systems
##
#H  @(#)$Id: sl42.g,v 0.92 2006/06/30 gap Exp $
##
#Y  Copyright (C) 1999,2001 University of St. Andrews, North Haugh,
#Y                          St. Andrews, Fife KY16 9SS, Scotland
##
Revision.("kan/examples/sl42_g") := 
   "@(#)$Id: sl42.g,v 0.92 2006/06/30 gap Exp $";

SetInfoLevel( InfoKan, 1 );
SetInfoLevel( InfoKnuthBendix, 1 );

Print( "\n==============================================================\n" );
Print( "2-generator example sl42.g, SL42.S15.SL42,   version 30/06/06\n" );
Print( "==============================================================\n\n" );

SetInfoLevel( InfoKan, 1 );
SetInfoLevel( InfoKnuthBendix, 1 );

M42 := SL(4,2);
isoP := IsomorphismPermGroup( M42 );
P42 := Image( isoP );
SetName( P42, "P42" );
s15 := SymmetricGroup( 15 );
isoF := IsomorphismFpGroup( M42 );
F42 := Image( isoF );
SetName( F42, "F42" );
free42 := FreeGroupOfFpGroup( F42 );
rels42 := RelatorsOfFpGroup( F42 );
gens42 := GeneratorsOfGroup( F42 );
x := gens42[1];  y := gens42[2];
alph := "XxYy";
ord := [4,3,2,1];
order := "shortlex";
rws42 := ReducedConfluentRewritingSystem( F42, ord, order, 0, alph );
Print( "rules for reduced rws for SL(4,2) with wreath order:\n" );
DisplayRwsRules( rws42 );;
acc42 := WordAcceptorOfReducedRws( rws42 );
Print( "word acceptor for this rws:\n", acc42, "\n" );
lang42 := SFAtoRatExp( acc42 );

rws42 := KBMAGRewritingSystem( F42);
auto := AutomaticStructure( rws42 );




