############################################################################
##
#W examples.gd			NQL				Rene Hartung
##
#H   @(#)$Id: examples.gd,v 1.3 2007/04/24 11:46:58 gap Exp $
##

############################################################################
##
#F ExamplesOfLPresentations (n)
##
## Returns some important examples of L-presented groups (e.g. Grigorchuk).
## (from "Endomorphic presentations of Branch Groups", Laurent Bartholdi")
##
DeclareGlobalFunction("ExamplesOfLPresentations");

############################################################################
##
#F EngelGroup ( <num> , <n> )
##
## Constructs an L-presentation for the n-th Engel Group on <num> generators.
##
DeclareGlobalFunction("EngelGroup");

############################################################################
##
#F  FreeNilpotentGroup( <n>, <class> )
##
## Constructs an L-presentation for a nilpotent group on <n> generators of 
## nilpotency class <class>.
##
DeclareGlobalFunction("FreeNilpotentGroup");

############################################################################
##
#F  GeneralizedFabrykowskiGuptaLpGroup ( <n> )
##
## returns an L-presentation for the generalized Fabrykowski-Gupta group for
## a positive integer <n>. For <n>=3 it returns the Fabrykowski-Group group.
##
DeclareGlobalFunction("GeneralizedFabrykowskiGuptaLpGroup");
