#############################################################################
##
#W    init.g               GAP 4 package 'nql'                   Rene Hartung  
##
#H   @(#)$Id: init.g,v 1.2 2007/02/28 14:03:58 gap Exp $
##

############################################################################
## 
## Put the name of the package into a single variable. This makes it 
## easier to change it to something else if necessary.
##
NQLPkgName:="NQL";

############################################################################
##
##    Declare the package and test for the existence of the package 
##    polycyclic.
##
DeclarePackage( NQLPkgName , "0.0",
  function()
    
    if TestPackageAvailability( "GAPDoc", "" ) = fail then
        Info( InfoWarning, 1, 
              "Loading the nql package: GAPDoc not available" );
    fi;

    if TestPackageAvailability( "polycyclic", "1.0" ) = fail then
        Info( InfoWarning, 1, 
              "Loading the nql package: package polycyclic must be available" );
        return fail;
    fi;

    return true;
end );

# install the documentation
DeclarePackageDocumentation( NQLPkgName, "doc", "NQL", 
        "Computation of nilpotent quotients" );


############################################################################
## 
#D Require other packages (polycyclic, GapDoc)
##
if IsList( TestPackageAvailability( "polycyclic", "1.0" ) ) then
    HideGlobalVariables( "BANNER" );
    BANNER := false;
    RequirePackage( "polycyclic" );
    UnhideGlobalVariables( "BANNER" );
fi;
if IsList( TestPackageAvailability( "GAPDoc", "" ) ) then
    HideGlobalVariables( "BANNER" );
    BANNER := false;
    RequirePackage( "GAPDoc", "" );
    UnhideGlobalVariables( "BANNER" );
fi;

############################################################################
##
#D Read .gd files
##
ReadPkg( NQLPkgName, "gap/hnf.gd");
ReadPkg( NQLPkgName, "gap/initqs.gd");
ReadPkg( NQLPkgName, "gap/homs.gd");
ReadPkg( NQLPkgName, "gap/tails.gd");
ReadPkg( NQLPkgName, "gap/consist.gd");
ReadPkg( NQLPkgName, "gap/cover.gd");
ReadPkg( NQLPkgName, "gap/endos.gd");
ReadPkg( NQLPkgName, "gap/buildnew.gd");
ReadPkg( NQLPkgName, "gap/extqs.gd");
ReadPkg( NQLPkgName, "gap/lpres.gd");
ReadPkg( NQLPkgName, "gap/quotsys.gd");
ReadPkg( NQLPkgName, "gap/nq.gd");
ReadPkg( NQLPkgName, "gap/nq_non.gd");

ReadPkg( NQLPkgName, "gap/examples.gd");
