#############################################################################
##
#W  example6.g               XMOD example files                 Chris Wensley
#W                                                                & Murat Alp
##
#H  $Id: example6.g,v 2.007 2006/07/05 gap Exp $
##
#Y  Copyright (C) 1999,2001 University of St. Andrews, North Haugh,
#Y                          St. Andrews, Fife KY16 9SS, Scotland
##
#############################################################################

Print("\nXMod example file example6.g (version 05/07/06) :-");
Print("\ntesting actor functions\n\n");

s3 := Group( (1,2), (2,3) );  
SetName( s3, "s3" );
X3 := XMod( s3, s3 );

reg3 := RegularDerivations( X3 );
Print("regular derivations of X3 have images list\n" );
imreg3 := ImagesList( reg3 );
Display( imreg3 );
Print("images table for these derivations:\n" );
Display( ImagesTable( reg3 ) );
wgt3 := WhiteheadGroupTable( X3 );
Print("X3 has Whitehead Group Table:\n");
Display( wgt3);
wpg3 := WhiteheadPermGroup( X3 );
gwpg3 := GeneratorsOfGroup( wpg3);
Print("Whitehead perm group wpg3 of X3 is ", wpg3, "\n");
Print("and has generators ", gwpg3, "\n\n");

sgsc3 := StrongGeneratorsStabChain( StabChain( wpg3 ) );
Print("WhitehadPermGroup has StrongGeneratorsStabChain\n", sgsc3, "\n" );
genchi3 := WhiteheadGroupGeneratingDerivations( X3 );
Print("Generating derivations are:\n", genchi3, "\n" );
genmor3 := List( genchi3, c -> Object2dEndomorphism( c ) );
Print("Generating morphisms are:\n", genmor3, "\n\n" );
